import { db } from "../db/main"
import { type Shortform } from "../db/main"
export function cacheShortforms(lists: Array<number> = []) {
	let shortforms = new Map();
	// console.log("Caching shortforms with lists:", lists);

	var n = 0;
	var shortforms_length = 0;
	var phrases_length = 0;
	if (lists.length < 1) {
		default_shortforms.map((sf: ShortformExportType) => {
			shortforms.set(sf.sf, { phrase: sf.p, last: sf.u });
			/*     
				n += 1;
				shortforms_length += sf.sf.length;
				phrases_length += sf.p.length;
			*/
		});
		/*
		console.log("Average shortform length:", shortforms_length / n);
		console.log("Average phrases length:", phrases_length / n);
		*/
	}
	else {
		lists.forEach(listid => {
			console.log("looking up shortforms for this listid:", listid)
			db.shortforms.where("listid").equals(listid).toArray().then(sfs => {
				sfs.forEach(sf => {
					shortforms.set(sf.shortform, sf)
				})
			})

		})
	}
	return shortforms;
}
export function expandShortform(
	cache: Map<string, any>,
	ShortForm: string,
): string {
	const u = new Date();
	const shortform = ShortForm.toLowerCase();
	if (cache.has(shortform)) {
		const phrase = cache.get(shortform).phrase;
		cache.set(shortform, { phrase: phrase, last: u });

		if (shortform.match(/(\d+)/) || ShortForm === shortform) {
			return phrase;
		} else if (ShortForm === shortform.toUpperCase() && ShortForm.length > 1) {
			return phrase.toUpperCase();
		} else if (/^\p{Lu}(\p{L}*)/u.test(ShortForm)) {
			return phrase.charAt(0).toUpperCase() + phrase.substring(1);
		} else {
			return phrase;
		}
	}
	return "";
}
